function [intervaltime,intervalindex,intervalfit,fitparams] = PostHocFitInterval(time,eyeposition,saccadetime,slowpause,slowduration)
  intervalnumber = numel(saccadetime);
  intervaltime = cell(intervalnumber,1);
  intervalindex = cell(intervalnumber,1);
  intervalfit = cell(intervalnumber,1);
  fitparams = cell(intervalnumber,1);
  for k = 1:intervalnumber
    intervalstart = saccadetime(k) + slowpause;
    intervalstop1 = intervalstart + slowduration;
    if k == intervalnumber
      intervalstop2 = time(end);
    else                    
      intervalstop2 = saccadetime(k+1) - 0.5;
    end
    intervalstop = min(intervalstop1,intervalstop2);
    intervalindex{k} = find(and(time>=intervalstart,time<=intervalstop));
    intervaltime{k} = time(intervalindex{k});
    if ~isempty(intervalindex{k})
      % Fit a line to each interval using the function 'computefit' below.
      [intervalfit{k},fitparams{k}] ...
        = PostHocComputeFit(intervaltime{k},eyeposition(intervalindex{k}),'line');
    end
  end
  fitparams = cell2mat(fitparams);  
end