function [VBLTimestamp1,VBLTimestamp2,refreshr,w1,w2,ifi]=PsychSetupAdHoc(refreshr,trialduration,okrspeed,c,ncycl,single,triple,updateparams,projector)
 
  singledisplay = single;
  tripledisplay = triple;
  
  speed = okrspeed;
    
  if updateparams == 0
    load('PsychSetup.mat')
    try
      nframes = round(FrameRate(singledisplay)/refreshr); 
    catch
      nframes = round(60/refreshr);
    end
  end
  
  %071015 create name for saving stimulus
  basename='Stim';
  st_ncycl=num2str(ncycl);
  st_v=num2str(speed);
  st_c=num2str(c);
  st_refreshr=num2str(refreshr);

  try
    mkdir('Stimuli');
  catch
  end
  fullname=['Stimuli/' basename '_c_' st_c '_v_' st_v '_ncycl_' st_ncycl  '_refreshr_' st_refreshr '.mat'];

  try
    
    if updateparams == 0
      
      try
        ifi = Screen('GetFlipInterval',w1,200);
      catch
        ifi=1/60;
      end
      
      white=WhiteIndex(singledisplay);
      black=BlackIndex(singledisplay);
      gray=(white+black)/2;
             
      if speed == 0
        frpcyc = 1;
      else
        frpcyc = (round(1/abs(speed)*360/ncycl*nframes));% frames for one cycle
      end
      
      try
        load (fullname);
      catch
      end

    end

    clear gratingalpha1 gratingalpha2;
    for i=1:frpcyc        
        
      if projector==10000 % i.e., skip for now
          
          % Add code here! XXX
          
      else
          
        grating1=sin(ncycl*horizontang1(1,:)+i*sign(okrspeed)/frpcyc*2*pi);
        grating1=gray+c.*(gray).*grating1; % contrast c
   	    grating1= 255*((grating1/255).^(1/2));
	    grating1=255-grating1;
        for k=1:3
          gratingalpha1(1,:,k,i)=grating1;
        end
        gratingalpha1(1,:,4,i)=255;
        centerleft1(i)=Screen('MakeTexture',w1, gratingalpha1(:,:,:,i));
        
        grating2=sin(ncycl*horizontang2(1,:)+i*sign(okrspeed)/frpcyc*2*pi);
  	    grating2=gray+c.*(gray).*grating2; % contrast c
	    grating2= 255*((grating2/255).^(1/2));
	    grating2=255-grating2;
        for k=1:3
          gratingalpha2(1,:,k,i)=grating2;
        end
        gratingalpha2(1,:,4,i)=255;
        centerleft2(i)=Screen('MakeTexture',w2, gratingalpha2(:,:,:,i));
    
      end
      
    end
    
    save(fullname,'gratingalpha1','gratingalpha2'); 

    if updateparams == 0

      verttext1 = Screen('MakeTexture',w1,vertmask1);
      verttext2 = Screen('MakeTexture',w2,vertmask2);

    else
        
      verttext1 = load('PsychStimulusAdHoc.mat','verttext1');
      verttext2 = load('PsychStimulusAdHoc.mat','verttext2');
      
    end
    
    if updateparams == 0
        
      if projector
          
          Screen('DrawTexture', w1, fog1, lineRect1, Screen1rect);
          Screen('DrawTexture', w1, verttext1,[],Screen1rect); 
          Screen('DrawTexture', w2, fog2, lineRect2, Screen2rect);
          Screen('DrawTexture', w2, verttext2,[],Screen2rect);
          
      else

          Screen('DrawTexture', w1, fog1, lineRect1, Screen1rectd1);
          Screen('DrawTexture', w1, verttext1,[],Screen1rectd1); 
          Screen('DrawTexture', w1, fog1, lineRect1, Screen1rectd2);
          Screen('DrawTexture', w1, verttext1,[],Screen1rectd2); 
          Screen('DrawTexture', w1, fog1, lineRect1, Screen1rectd3);
          Screen('DrawTexture', w1, verttext1,[],Screen1rectd3); 
          Screen('DrawTexture', w2, fog2, lineRect2, Screen2rect);
          Screen('DrawTexture', w2, verttext2,[],Screen2rect);
          
      end

      VBLTimestamp1 = Screen('Flip', w1); %Initially synchronize with retrace, take base time in VBLTimestamp
      VBLTimestamp2 = Screen('Flip', w2); %Initially synchronize with retrace, take base time in VBLTimestamp

    else
        
      VBLTimestamp1 = load('PsychStimulusAdHoc.mat','VBLTimestamp1');
      VBLTimestamp2 = load('PsychStimulusAdHoc.mat','VBLTimestamp2');
      
    end
    
    if projector
        
        save('PsychStimulusAdHoc.mat','VBLTimestamp1','VBLTimestamp2', ...
                                      'refreshr','w1','w2','fog1','fog2', ...
                                      'ifi','frpcyc','ncycl','centerleft1', ...
                                      'centerleft2','verttext1','verttext2', ...
                                      'lineRect1','lineRect2', ...
                                      'Screen1rect','Screen2rect');
        
    else
        
        save('PsychStimulusAdHoc.mat','VBLTimestamp1','VBLTimestamp2', ...
                                      'refreshr','w1','w2','fog1','fog2', ...
                                      'ifi','frpcyc','ncycl','centerleft1', ...
                                      'centerleft2','verttext1','verttext2', ...
                                      'lineRect1','lineRect2', ...
                                      'Screen1rectd1','Screen1rectd2', ...
                                      'Screen1rectd3','Screen2rect');
       
    end

  catch
    %this "catch" section executes in case of an error in the "try" section
    %above.  Importantly, it closes the onScreen window if its open.
    if updateparams == 0
      %Screen('CloseAll');
    end
    ShowCursor;
    Priority(0);
    psychrethrow(psychlasterror);
  end

end